//////////////////////////////////////////////////////////////////////////////////
//
// Set up lab  
//
//////////////////////////////////////////////////////////////////////////////////
//
// IBM Toolbox for Java
// (C) Copyright IBM Corp. 2003, 2003
// All rights reserved.
// US Government Users Restricted Rights -
// Use, duplication, or disclosure restricted
// by GSA ADP Schedule Contract with IBM Corp.
//
//////////////////////////////////////////////////////////////////////////////////

import com.ibm.as400.access.AS400;
import com.ibm.as400.access.AS400Message;
import com.ibm.as400.access.CommandCall;
import com.ibm.as400.access.FTP;
import java.io.*;

public class FTPprograms {
    public static void main(String[] args)
    {
        String server = null; //String to hold server name
        String user = null;   //String to hold user name
        String pwd = null;    //String to hold password
        System.out.print("Please enter the iSeries system name you wish to connect to:  ");
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in)); 
        //  read the system name from the command-line 
        try {
            server = br.readLine(); 
        }
        catch (IOException ioe) {
            System.out.println("IO error trying to read server name!"); 
            System.exit(1); 
        }
        System.out.print("Please enter your user id:  ");
        //  read the user id from the command-line 
        try {
            user = br.readLine(); 
        }
        catch (IOException ioe) {
            System.out.println("IO error trying to read user id!"); 
            System.exit(1); 
        }
        System.out.print("Please enter your password:   ");
        //  read the password from the command-line 
        try {
            pwd = br.readLine(); 
        }
        catch (IOException ioe) {
            System.out.println("IO error trying to read password!"); 
            System.exit(1); 
        }
        try {
            AS400 system = new AS400(server, user, pwd);

            CommandCall command = new CommandCall(system);


            //Create the COMMON.LIB library for the Toolbox DataQueue exercise
            StringBuffer lib = new StringBuffer();
            lib.append("mkdir '/QSYS.LIB/COMMON.LIB'");
            lib.append(" ");

            String commandString = lib.toString ();

            if (command.run(commandString))
                System.out.println("The command was successful.");
            else
                System.out.println("The command failed.");

            AS400Message[] messageList = command.getMessageList();
            for (int i=0; i < messageList.length; i++) {
                System.out.println (messageList[i].getID() + ":" +
                                    messageList[i].getText());
            }

            StringBuffer buffer = new StringBuffer();
            buffer.append ("mkdir '/java'");
            buffer.append (" ");

            commandString = buffer.toString ();

            if (command.run(commandString))
                System.out.println("The command was successful.");
            else
                System.out.println("The command failed.");

            messageList = command.getMessageList();
            for (int i=0; i < messageList.length; i++) {
                System.out.println (messageList[i].getID() + ":" +
                                    messageList[i].getText());
            }

            for (int i=1; i<51; i++) {
                StringBuffer crtusrprfdir = new StringBuffer();
                if (i<10) {
                    crtusrprfdir.append("mkdir '/java0" + i + "'");
                    System.out.println(crtusrprfdir);
                    crtusrprfdir.append (" ");
                }
                else {
                    crtusrprfdir.append ("mkdir '/java" + i+"'");
                    crtusrprfdir.append (" ");
                }

                String commandString1 = crtusrprfdir.toString ();

                if (command.run(commandString1))
                    System.out.println("The command was successful.");
                else
                    System.out.println("The command failed.");


                AS400Message[] messageList5 = command.getMessageList();
                for (int j=0; j < messageList5.length; j++) {
                    System.out.println (messageList5[j].getID() + ":" +
                                        messageList5[j].getText());
                }

                FTP client = new FTP(server, user, pwd);
                try {
                    System.out.println("Executing connect()");
                    client.connect();
                    System.out.println("Executing cd(/)");
                    client.cd("/");
                    if (i<10){
                        System.out.println("Executing cd(/java0" +i+")");
                        client.cd("/JAVA0" + i);
                    }
                    else{
                        System.out.println("Executing cd(/java" +i+")");
                        client.cd("/JAVA" + i);
                    }
                    System.out.println("Executing setDataTransferType()");
                    client.setDataTransferType(FTP.BINARY);
                    System.out.println("Executing put(SimpleProgram.jar)");
                    client.put("./SimpleProgram.jar", "SimpleProgram.jar");
                    System.out.println("Executing disconnect()");
                    client.disconnect();
                }
                catch (Exception e) {
                    System.out.println(e);
                }

            }



            for (int j=1; j<51; j++) {
                StringBuffer crtusrprf = new StringBuffer();
                if (j<10) {
                    crtusrprf.append("CRTUSRPRF USRPRF(Java0" + j + ") Password(Java0" + j + "1) inlpgm(qsys/qcmd)");
                    System.out.println(crtusrprf);
                    crtusrprf.append (" ");
                }
                else {
                    crtusrprf.append ("CRTUSRPRF USRPRF(Java" + j + ") Password(Java" + j + "1) inlpgm(qsys/qcmd)");
                    crtusrprf.append (" ");
                }

                String commandString5 = crtusrprf.toString ();

                if (command.run(commandString5))
                    System.out.println("The command was successful.");
                else
                    System.out.println("The command failed.");


                AS400Message[] messageList5 = command.getMessageList();
                for (int i=0; i < messageList5.length; i++) {
                    System.out.println (messageList5[i].getID() + ":" +
                                        messageList5[i].getText());
                }
            }
        }
        catch (Exception e) {
            System.out.println ("Error: " + e);
        }


        System.exit (0);
    } 


}

