//////////////////////////////////////////////////////////////////////////////////
//
// Program Call / PCML example
//
//////////////////////////////////////////////////////////////////////////////////
//
// This source is an example of IBM Toolbox for Java "ProgramCall".
// IBM grants you a nonexclusive license to use this as an example
// from which you can generate similar function tailored to
// your own specific needs.
//
// This sample code is provided by IBM for illustrative purposes
// only. These examples have not been thoroughly tested under all
// conditions. IBM, therefore, cannot guarantee or imply
// reliability, serviceability, or function of these programs.
//
// All programs contained herein are provided to you "AS IS"
// without any warranties of any kind.  The implied warranties of
// merchantablility and fitness for a particular purpose are
// expressly disclaimed.
//
// IBM Toolbox for Java
// (C) Copyright IBM Corp. 1998, 1998
// All rights reserved.
// US Government Users Restricted Rights -
// Use, duplication, or disclosure restricted
// by GSA ADP Schedule Contract with IBM Corp.
//
//////////////////////////////////////////////////////////////////////////////////




 import com.ibm.as400.data.ProgramCallDocument;
 import com.ibm.as400.data.PcmlException;
 import com.ibm.as400.access.AS400;
 import com.ibm.as400.access.AS400Message;

 //
 // This program calls i5/OS API QSYRUSRI (Retrieve User Information)
 // to get information on the current user.
 //

 public class qsyrusri {


     public static void main(String[] argv)
     {
         ProgramCallDocument pcml;
         boolean rc = false;
         String msgId, msgText;
         Object value;

         System.setErr(System.out);

         // Construct AS400 without parameters, user will be prompted
         // for system name, userid and password.
         AS400 system = new AS400();

         try
         {
             System.out.println("Beginning PCML Example..");
             System.out.println("    Constructing ProgramCallDocument for QSYRUSRI API...");

             // Construct ProgramCallDocument.
             // First parameter is system to connect to.
             // Second parameter is pcml resource name. In this example,
             // serialized PCML file "qsyrusri.pcml.ser" or
             // PCML source file "qsyrusri.pcml" must be found in the classpath.
      // ---------------------------------------------------------------
      //             Intro Lab Exercise #5 Part #1 - Insert code here.
      // ---------------------------------------------------------------

      // ---------------------------------------------------------------
      //                           End of code.
      // ---------------------------------------------------------------

             // Set input parameters. Several parameters have default values
             // specified in the PCML source. Do not need to set them using Java code.
             System.out.println("    Setting input parameters...");
             pcml.setValue("qsyrusri.receiverLength",
                            new Integer((pcml.getOutputsize("qsyrusri.receiver"))));

             // Request to call the API
             // User will be prompted to sign on to the system
             System.out.println("    Calling QSYRUSRI API.");
             rc = pcml.callProgram("qsyrusri");

             // If return code is false, we received messages from the server
             if(rc == false)
             {
                 // Retrieve list of server messages
                 AS400Message[] msgs = pcml.getMessageList("qsyrusri");

                 // Iterate through messages and write them to standard output
                 for (int m = 0; m < msgs.length; m++)
                 {
                     msgId = msgs[m].getID();
                     msgText = msgs[m].getText();
                     System.out.println("    " + msgId + " - " + msgText);
                 }
                 System.out.println("** Call to QSYRUSRI failed. See messages above **");
                 System.exit(0);
             }
             // Return code was true, call to QSYRUSRI succeeded
             // Write some of the results to standard output
             else
             {
                 value = pcml.getValue("qsyrusri.receiver.bytesReturned");
                 System.out.println("        Bytes returned:      " + value);
                 value = pcml.getValue("qsyrusri.receiver.bytesAvailable");
                 System.out.println("        Bytes available:     " + value);
      // ---------------------------------------------------------------
      //             Intro Lab Exercise #5 Part #2 - Insert code here.
      // ---------------------------------------------------------------

      // ---------------------------------------------------------------
      //                           End of code.
      // ---------------------------------------------------------------
                 System.out.println("        Profile name:        " + value);
                 value = pcml.getValue("qsyrusri.receiver.previousSignonDate");
                 System.out.println("        Previous signon date:" + value);
                 value = pcml.getValue("qsyrusri.receiver.previousSignonTime");
                 System.out.println("        Previous signon time:" + value);
             }
         }
         catch (PcmlException e)
         {
             System.out.println(e.getLocalizedMessage());
             e.printStackTrace();
             System.out.println("*** Call to QSYRUSRI failed. ***");
             System.exit(0);
         }

         System.exit(0);
     }
 }

